summaryrefslogtreecommitdiff
path: root/apps/plugins/puzzles/genhelp.sh
diff options
context:
space:
mode:
authorFranklin Wei <git@fwei.tk>2017-06-03 13:45:07 -0400
committerFranklin Wei <git@fwei.tk>2017-06-03 13:45:07 -0400
commit552a271c6fea8d36390858ca6d12c4c98f663002 (patch)
tree046ea6cdc0cbadae014715c02af6ada4e966a92c /apps/plugins/puzzles/genhelp.sh
parentcefbde0bbb5f90523233a56ca6c0b0699b4b359e (diff)
downloadrockbox-552a271c6fea8d36390858ca6d12c4c98f663002.zip
rockbox-552a271c6fea8d36390858ca6d12c4c98f663002.tar.gz
rockbox-552a271c6fea8d36390858ca6d12c4c98f663002.tar.bz2
rockbox-552a271c6fea8d36390858ca6d12c4c98f663002.tar.xz
puzzles: remove redundant help content
It used to be that each puzzle had a complete copy of the entire puzzles manual and the "quick help" text for every single puzzle. This was obviously a waste, so now each puzzle only has the sections of the manual that apply to it, saving about 100KB or so per puzzle. This also has the added benefit of shrinking binary size enough to allow full help support on the c200v2, which has been enabled. Change-Id: I76c799635de058e4a48e0c18b79537857af7cf85
Diffstat (limited to 'apps/plugins/puzzles/genhelp.sh')
-rwxr-xr-xapps/plugins/puzzles/genhelp.sh70
1 files changed, 35 insertions, 35 deletions
diff --git a/apps/plugins/puzzles/genhelp.sh b/apps/plugins/puzzles/genhelp.sh
index f243a1d..293c58b 100755
--- a/apps/plugins/puzzles/genhelp.sh
+++ b/apps/plugins/puzzles/genhelp.sh
@@ -1,5 +1,5 @@
#!/bin/bash
-# usage: ./genhelp.sh > helpcontent.sh
+# usage: ./genhelp.sh
#
# expects halibut to be installed in $PATH:
# http://www.chiark.greenend.org.uk/~sgtatham/halibut
@@ -16,37 +16,37 @@ cat puzzles.txt.tmp | awk 'BEGIN { a=1; } /Appendix A/ { a = 0; } a==1' > puzzle
rm puzzles.txt.tmp
-cat <<EOF
-/* auto-generated by genhelp.sh */
-/* DO NOT EDIT! */
-const int help_chapteroffsets[] = {
-EOF
-
-# generate chapter offset list
-cat puzzles.txt | awk 'BEGIN { x = -1; n = 0; } /#Chapter/ { if($0 !~ / 1:/ && $0 !~ / 2:/) { if( x == -1 ) { x = n; } print n - x","; }} {n += length($0) + 1; if(x >= 0 && $0 !~ /Chapter/ && substr($0, 1, 1) == "#") n += 1;}'
-
-cat <<EOF
-};
-
-const char help_text[] =
-EOF
-
-# get starting byte offset
-start=`cat puzzles.txt | awk 'BEGIN { x = -1; n = 0; } /#Chapter/ { if($0 !~ / 1:/ && $0 !~ / 2:/) { if( x == -1 ) { x = n; print x + 1; } print n - x","; }} {n += length($0) + 1; if(x >= 0 && $0 !~ /Chapter/ && substr($0, 1, 1) == "#") n += 1;}' | head -n 1`
-
-# generate content
-cat puzzles.txt | tail -c +$start | awk '{gsub(/\\/,"\\\\"); if($0 !~ /Chapter/ && substr($0, 1, 1) == "#") begin = "\\n"; else begin = ""; last = substr($0, length($0), 1); if(length($0) == 0 || last == "|" || last == "-" || (term == "\\n" && last == "3")) term="\\n"; else term = " "; print "\"" begin $0 term "\"";}'
-
-cat <<EOF
-;
-
-EOF
-
-# length of longest chapter (not including null)
-maxlen=`cat puzzles.txt | awk 'BEGIN { x = -1; n = 0; } /#Chapter/ { if($0 !~ / 1:/ && $0 !~ / 2:/) { if( x == -1 ) { x = n; } print n - x","; }} {n += length($0) + 1; if(x >= 0 && $0 !~ /Chapter/ && substr($0, 1, 1) == "#") n += 1;}' | awk 'BEGIN { max = 0; last = 0; } { if($0 - last > max) max = $0 - last; last = $0; } END { print max }'`
-
-# remember number of chapters
-num=`cat puzzles.txt | awk 'BEGIN { x = -1; n = 0; } /#Chapter/ { if($0 !~ / 1:/ && $0 !~ / 2:/) { if( x == -1 ) { x = n; } print n - x","; }} {n += length($0) + 1; if(x >= 0 && $0 !~ /Chapter/ && substr($0, 1, 1) == "#") n += 1;}' | wc -l`
-
-echo "const int help_maxlen = "$maxlen";"
-echo "const int help_numchapters = "$num";"
+# now split into different files
+mkdir -p help
+
+cat puzzles.txt | awk 'BEGIN { file = "none"; }
+ /#Chapter/ {
+ if($0 !~ / 1:/ && $0 !~ / 2:/)
+ {
+ if(file != "none")
+ print ";" > file;
+ file = "help/"tolower($3$4)".c";
+ if($3 ~ "Rectangles")
+ file = "help/rect.c";
+ print "/* auto-generated by genhelp.sh */" > file;
+ print "/* DO NOT EDIT! */" > file;
+ print "const char help_text[] = " > file; }
+ }
+ file != "none" {
+ gsub(/\\/,"\\\\");
+ if($0 !~ /Chapter/ && substr($0, 1, 1) == "#")
+ begin = "\\n";
+ else begin = "";
+ last = substr($0, length($0), 1);
+ if(length($0) == 0 || last == "|" || last == "-" || (term == "\\n" && last == "3"))
+ term="\\n";
+ else term = " ";
+ print "\"" begin $0 term "\"" > file;
+ }
+ END {
+ print ";" > file;
+ }
+'
+
+# generate quick help from gamedesc.txt
+cat src/gamedesc.txt | awk -F ":" '{print "const char quick_help_text[] = \""$5"\";" >> "help/"$1".c" }'